Contributing to ps4-waker
=========================

:tada: Thanks for taking the time to contribute! :tada:

## Having trouble? Have a question?

If you're having trouble using `ps4-waker` or otherwise have a question
and are about to file an issue asking for help, make sure you:

1. [Read through and follow ALL troubleshooting][1] entries in the
   wiki. A lot of common points of confusion have been explained there,
   so make use of it!
2. Take the time to look through [existing, resolved issues][2] in case
   someone else had a similar issue that didn't get added to the wiki.
3. Include enough information to reproduce your problem. That includes
   exact steps taken, copies of output from commands run (with any
   sensitive information removed) etc.
4. Make sure you test against the latest version of the project to see
   if the problem has already been fixed.

Please do *not* email me directly, unless you have a *very* good
reason. I don't have time to provide personal support for free, so if
you absolutely cannot find help elsewhere please at least ask for help
on a public forum, like the issue tracker here, so others in the future
can potentially benefit from your question.

## Contributing code

So you want to contribute some code—awesome! When doing so, please try to:

* Follow the same coding style as used in the project. We have an
  automated linter that will look for the big things, but it may not
  catch all the aesthetic bits. Do your best!
* Update or add a unit test to verify your change. If you cannot
  reasonably do this, or feel its unnecessary, please explain why.
* Write [good commit messages][3], explain what your change does, and
  why.
* Keep pull requests simple: change one thing at a time, unless
  absolutely necessary; if it *is* necessary to do more than one thing
  at once, explain why, and consider opening an issue to discuss your
  intended changes before starting work on them.

[1]: https://github.com/dhleong/ps4-waker/wiki/Troubleshooting
[2]: https://github.com/dhleong/ps4-waker/issues?q=is%3Aissue+is%3Aclosed+label%3Ahelpme
[3]: https://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
