"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const _require = require('./base'),
      CommandOnDevice = _require.CommandOnDevice;

module.exports = class StartCommand extends CommandOnDevice {
  constructor(args) {
    super();
    this.titleId = args[0]; // eslint-disable-line

    if (!this.titleId) {
      throw new Error('A title id must be provided to start');
    }
  }

  onDevice(ui, device) {
    var _this = this;

    return _asyncToGenerator(function* () {
      yield device.startTitle(_this.titleId, {
        ui,
        autoQuit: true // default, but let's be explicit

      });
    })();
  }

};